import processing.core.*; import krister.Ess.*; import processing.opengl.*; import java.awt.Graphics; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class ES extends PApplet {


Mainloop mainloop;
Ship ship;
Pointer pointer;
ShotPool sp;
Camera cam;
Field field;
Stage stage;
EnemyPool ep;
AudioChannel myChannel;
AudioChannel se;
boolean noPlay;
boolean mouseReleased;
final int TEMPO = 15;
public void setup(){
  size(480 ,480 ,OPENGL);
  framerate(30);
  Ess.start(this);
  myChannel = new AudioChannel("loop1.wav");
  noPlay = true;
  mainloop = new Mainloop();
  mainloop.init();
  
}
int pos = 0;
public void draw() {
 
  mainloop.update();
}
public void mouseReleased(){
  mouseReleased = true;
}
public boolean getMouseReleased(){
  boolean mr =mouseReleased;
  mouseReleased = false;
  return mr;
}
public float[] multiple(float[] a,float mul){
  float[] b = new float[a.length];
  for(int i = a.length - 1;0 <= i;i --){
    b[i] = a[i] * mul;
  }
  return b;
}
public float[][] multiple(float[][] a,float mul){
  float[][] b = new float[a.length][];
  for(int i = a.length - 1;0 <= i;i --){
    b[i] = new float[a[i].length];
    for(int j = a[i].length - 1;0 <= j;j --){
      b[i][j] = a[i][j] * mul;
    }
  }
  return b;
}
class Mainloop{
  final State TITLE ,GAME;
  State state;
   Mainloop(){
     ship = new Ship();
     pointer = new Pointer();
     sp = new ShotPool();
     cam = new Camera();
     field = new Field();
     ep = new EnemyPool();
     stage = new Stage();
     TITLE = new Title();
     GAME = new Game();
     state = TITLE;
  }
   public void init(){
     state.init();
  }
   public void update(){
    state.update();
  }
   public void changeState(State s){
    state = s;
    init();
  }
}
interface State{
  public void init();
  public void update();
}
class Game implements State{
  public void init(){
    ship.init();
    pointer.init();
    sp.init();
    cam.init();
    field.init();
    ep.init();
    stage.init(1);
  }
  public void update(){
    noCursor();
    background(0,50,60);
    smooth();
    ellipseMode(CENTER);
    pushMatrix();
    
    ship.update();
    popMatrix();
    pushMatrix();
    
    pointer.update();
    
    sp.update();
    popMatrix();
    
    pushMatrix();
    ep.update();
    popMatrix();
    pushMatrix();
    field.update();
    stage.update();
    popMatrix();
    popMatrix();
    if(ship.shield < 0)mainloop.changeState(mainloop.TITLE);
    if(noPlay){
      if(myChannel.state == Ess.PLAYING)myChannel.stop();
    }else{
      if(myChannel.state == Ess.STOPPED)myChannel.resume();
    }
  }
}
class Title implements State{
  public void init(){
    ship.shield = ship.MAXSHIELD;
    pointer.fx = ship.fx;
    pointer.fy = ship.fy;
  }
  public void update(){
    if(dist(width / 2 ,height / 2 ,mouseX ,mouseY) < 20 * height / 480){
      cursor(HAND);
      if(mousePressed && getMouseReleased()){
        mainloop.changeState(mainloop.GAME);
        
      }
    }else if(dist(width / 2 + height * 2.0f / 5.0f ,height * 9.0f / 10.0f ,mouseX ,mouseY) <  20 * height / 480){
      cursor(HAND);
      if(mousePressed && getMouseReleased()){
        if(noPlay){
          noPlay = false;
          myChannel.play(Ess.FOREVER);
        }else noPlay = true;
      }
    }else{
      cursor(ARROW);
    }
    background(0,50,60);
    smooth();
    
    ellipseMode(CENTER);
    ellipse(height * 2.0f / 5.0f ,height * 2.0f / 5.0f ,height / 12 ,height / 12);

    cam.inTitle();
    cam.setCamera();
    pushMatrix();
    scale(height / 480); 
    pushMatrix();
    ship.inTitle();
    popMatrix();
    field.update();
    popMatrix();
    
    stroke(122);
    if(noPlay)fill(122);
    else fill(255);
    //ellipse(modelX(width / 2 ,height / 2 ,0) ,modelY(width / 2 ,height / 2 ,0) ,80 ,80);
    //ellipse((width / 2 + height  / 3.0) / 2.0 ,(width * 5.0 / 6.0) / 2.0 ,height / 6 ,height / 6);
    //translate(height * 5.0 / 6.0 ,height * 5.0 / 6.0  ,0.0);
    //translate(screenX(height / 2  - 50 ,height / 2  - 50 ,0) ,screenY(height / 2  - 50 ,height / 2  - 50 ,0),screenZ(height / 2  - 50 ,height / 2  - 50 ,0));
    //ellipse(0 ,0 ,height / 6 ,height / 6);

    if(noPlay){
      if(myChannel.state == Ess.PLAYING)myChannel.stop();
    }else{
      if(myChannel.state == Ess.STOPPED)myChannel.resume();
    }
  }
}
class Camera{
  float eyeX ,eyeY ,eyeZ;
  float centerX ,centerY ,centerZ;
  float upX ,upY ,upZ;
   Camera(){
    init();
  }
  public void init(){
    eyeX = 0;
    eyeY = 0;
    eyeZ = (height/2.0f) / tan(PI*60.0f / 360.0f);
    centerX = 0;
    centerY = 0;
    centerZ = 0;
    upX = 0;
    upY = 1;
    upZ = 0;
  }
  public void inTitle(){
    eyeX = 0;
    eyeY = 0;
    eyeZ = (height) / tan(PI*60.0f / 360.0f);
    centerX = 0;
    centerY = 0;
    centerZ = 0;
    upX = 0;
    upY = 1;
    upZ = 0;
  }
 
   public void update(){
    eyeX = ship.x * height / 480;
    eyeY = ship.y * height / 480;
    eyeZ = ship.z + (height/2.0f) / tan(PI*60.0f / 360.0f);
    centerX = ship.x * height / 480;
    centerY = ship.y * height / 480;
    centerZ = ship.z;
    upX = 0;
    upY = 1;
    upZ = 0;
  }
   public void setCamera(){
    camera(eyeX ,eyeY ,eyeZ ,centerX ,centerY ,centerZ ,upX ,upY ,upZ);
  }
}
  

final int BULLET = 0;
final int MISSILE = 1;
final int BOUND = 2;
final int THREEWAY = 3;
final int FOURWAY = 4;
final int SCATTER = 5;
final int PLANE = 6;
final int NIGHTWING = 7;
final int ICEBERG = 8;
final int SWINE = 9;
abstract class Enemy {
  Shape shape;
  Enemy parent;
  Moving moving;
  float fx ,fy ,fz;
  float x ,y ,z;
  float vx ,vy;
  float sx ,sy ,sz;
  float largeness;
  float power;
  float maxhp;
  float hp;
  int attackTerm;
  int reloadTerm;
  int vanishTerm;
  boolean start;
  private int attackCnt;
  private int reloadCnt;
  private int attackTimes;
  private float dam;
  private boolean exist;
  private boolean destroyed;
  private boolean attacking;
  private boolean vanished;
  private int vanCnt;
  int cnt;
  Enemy(Enemy parent ,Moving moving,float hp ,float fx ,float fy ,float fz ,float vx ,float vy){
    this.parent = parent;
    this.moving = moving;
    this.fx = fx;
    this.fy = fy;
    this.fz = fz;
    this.vx = vx;
    this.vy = vy;
    this.maxhp = hp;
    this.hp = maxhp;
    if(maxhp < 5)largeness = 15;
    else largeness = sqrt(maxhp - 4) * 5 + 15;
    x = field.transX(fx ,fy ,fz);
    y = field.transY(fx ,fy ,fz);
    z = field.transZ(fx ,fy ,fz);
    exist =true;
    destroyed = false;
    vanished = false;
    start = true;
    attacking = true;
    
    attackCnt = 0;
    reloadCnt = 0;
    attackTimes = 0;
    dam = 0;
    cnt = 0;
    vanCnt = 0;
  }
  public void update(){
    if(0 < vanishTerm && vanishTerm <= cnt)vanish();
   if(vanished){
     if(30 < vanCnt)setExist(false);
      vanCnt ++; 
   }else if(start){
     float fr = dist(fx ,fy ,field.x ,field.y );
     if(field.radius < fr){
       fx = fx * 0.99f;
       fy = fy * 0.99f;
     }else if(5 < abs(fz)){
       fz -= fz /abs(fz) * 5;
     }else {
       fz = 0;
       start = false;
     }
   }else {
     if(attacking){
       
       attackCnt ++;
       attack(attackTimes ,attackCnt);
       if(attackTerm < attackCnt){
        attacking = false;
        attackCnt = 0;
        attackTimes ++;
       }
       
      } else{
      reloadCnt ++;
      if(reloadTerm < reloadCnt){
        if(0 < attackTerm)attacking = true;
        reloadCnt = 0;
       } 
     }
     moving.update(attacking);
     float fr = dist(fx ,fy ,field.x ,field.y );
     if(field.radius < fr){
       bonk(fr);
     }
     if(dist(ship.x ,ship.y ,ship.z ,x ,y ,z) < largeness){
        ship.damage(power);
     }
   }
    x = field.transX(fx ,fy ,fz);
    y  = field.transY(fx ,fy ,fz);
    z = field.transZ(fx ,fy ,fz);
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    sx = dam * random(5.0f);
    sy = dam * random(5.0f);
    sz = dam * random(5.0f);
    noFill();
    translate(x + sx, y + sy, z + sz);
    roll();
    if(start)stroke(122);
    else if(vanished){
      if(destroyed){
        stroke(122);
        scale(1 + (900.0f - (30 - (float)vanCnt) * (30 - (float)vanCnt)) / 100.0f);
      }else{
        stroke(122);
        scale(1.0f - (900.0f - (30 - (float)vanCnt) * (30 - (float)vanCnt)) / 900.0f);
      }
    }
    else stroke(255);
    if(parent == null)strokeWeight(2);
    else strokeWeight(1);
    beginShape(LINE_LOOP);
    for(int i = 0; i < ax.length ;i ++){
      vertex(ax[i] ,ay[i] ,az[i]);
    }
    endShape();
    strokeWeight(1);
    if(dam > 0)dam -= 1.0f;
    else dam = 0;
    cnt ++;
  }
   public void setExist(boolean e){
    exist = e;
  }
  public void destroy(){
    float rec;
    if(parent == null){
      stage.wait -= (float)maxhp * stage.rank / 2;
      rec = log(maxhp + 1);
    }else rec = log(maxhp + 1) / 10;
    ship.recPlus(rec);
    destroyed = true;
    vanished = true;
  }
  public void vanish(){
    destroyed = false;
    vanished = true;
  }
   public boolean isExist(){
    return exist;
  }
  public float damage(float power){
    float h;
    if(start || destroyed)h = 0;
    else{
      h =  hp;
      hp -= power;
      dam = power;
      if(hp <= 0)destroy();
    }
    return h;
  }
  public float aim(){
    return atan2(vy ,vx);
  }
  public abstract void attack(int attackTerm ,int attackCnt);
  public abstract void bonk(float fr);
  public abstract void roll();
}
Shape BULLET_SHAPE;
class Bullet extends Enemy{
  Bullet(Enemy parent ,Moving moving ,float hp ,float fx ,float fy ,float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    reloadTerm = 0;
    attackTerm = 0;
    vanishTerm = -1;
    power = 5.0f;
    if(BULLET_SHAPE == null){
      float[] a = {-2.2f ,-0.8f ,0 ,0.8f ,1.0f};
      float[] b = {0  ,0.6f ,1 ,0.6f ,0};
      BULLET_SHAPE = new Pole(a ,b ,6);
    }
    shape = (Shape)BULLET_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){}
  public void bonk(float fr){
    vanish();
  }
  public void roll(){
    rotateZ(aim());
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
  }
}
Shape MISSILE_SHAPE;
class Missile extends Enemy {
  Missile(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 0;
    attackTerm = 0;
    vanishTerm = 300;
    if(MISSILE_SHAPE == null){
      float[] a = {-1 ,-1.5f  ,-1   ,-0.5f ,0 ,2   ,2.5f};
      float[] b = {0  ,1     ,0.7f  ,0.3f  ,1 ,0.7f ,0};
      MISSILE_SHAPE = new Pole(a ,b ,6);
    }
    shape = (Shape)MISSILE_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){}
  public void bonk(float fr){
  }
  public void roll(){
    rotateZ(aim());
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
  }
}
Shape BOUND_SHAPE;
class Bound extends Enemy {
  Bound(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 5.0f;
    reloadTerm = 0;
    attackTerm = 0;
    vanishTerm = 600;
    if(BOUND_SHAPE == null){
      float[] a = {-1 ,0 ,1};
      float[] b = {0 ,1 ,0};
      BOUND_SHAPE = new Pole(a ,b ,6);
    }
    shape = (Shape)BOUND_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){}
  public void bonk(float fr){
    float vr = dist(0 ,0 ,vx ,vy);
    float theta = atan2(fy ,fx);
    float rad = atan2(vy ,vx);
    vx = - vr * cos(2 * theta -rad);
    vy = - vr * sin(2 * theta - rad);
    
    fx = fx / fr * field.radius;
    fy = fy / fr * field.radius;
  }
  public void roll(){
    rotateY(HALF_PI);
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
  }
}
Shape THREEWAY_SHAPE;
class Threeway extends Enemy {
  Threeway(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 60;
    attackTerm = 30;
    vanishTerm = 600;
    if(THREEWAY_SHAPE == null){
      float[] a = {-1.2f ,-1  ,-0.6f   ,0  ,0.6f ,1   ,1.2f};
      float[] b = {0  ,0.5f     ,0.8f  ,1 ,0.8f  ,0.5f ,0};
      THREEWAY_SHAPE = new Pole(a ,b ,6);
    }
    shape = (Shape)THREEWAY_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){
    if(attackCnt % 30 == 1){
      float aim = atan2(ship.fy - fy ,ship.fx -fx);
      ep.addEnemy(this ,BULLET ,new Straight() ,30 ,fx ,fy ,fz ,cos(aim) * 5.0f,sin(aim) * 5.0f);
      ep.addEnemy(this ,MISSILE ,new Homing(TWO_PI / 360) ,10 ,fx ,fy ,fz ,cos(aim + PI / 3) * 3.0f ,sin(aim + PI / 3) * 3.0f);
      ep.addEnemy(this ,MISSILE ,new Homing(TWO_PI / 360) ,10 ,fx ,fy ,fz ,cos(aim - PI / 3) * 3.0f ,sin(aim - PI / 3) * 3.0f);
    }
  }
  public void bonk(float fr){
  }
  public void roll(){
    rotateY(HALF_PI);
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
  }
}
Shape FOURWAY_SHAPE;
class Fourway extends Enemy {
  Fourway(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 60;
    attackTerm = 30;
    vanishTerm = 600;
    if(FOURWAY_SHAPE == null){
      float[][] a = {
        {-1.2f ,-0.6f ,0   ,0.6f ,1.2f},
        {-0.4f ,-0.4f ,-0.4f  ,0.4f ,0.4f}
      };
      float[][] b ={
        {0    ,0.6f  ,1.2f ,0.6f ,0},
        {0.4f  ,0.4f  ,0.4f   ,0.4f  ,0.4f}
      };
      FOURWAY_SHAPE = new Pole(a ,b ,8);
    }
    shape = (Shape)FOURWAY_SHAPE.clone();
    shape.multi(largeness * 1.5f);
  }
  public void attack(int attackTerm ,int attackCnt){
    if(attackCnt % 30 == 1){
      float aim = TWO_PI * (float)(cnt % 180) / 180;
      ep.addEnemy(this ,BOUND ,new Straight() ,10 ,fx ,fy ,fz ,cos(aim) * 5.0f,sin(aim) * 5.0f);
      ep.addEnemy(this ,BOUND ,new Straight() ,10 ,fx ,fy ,fz ,cos(aim + PI / 2) * 5.0f ,sin(aim + PI / 3) * 5.0f);
      ep.addEnemy(this ,BOUND ,new Straight() ,10 ,fx ,fy ,fz ,cos(aim + PI) * 5.0f ,sin(aim + PI / 3) * 5.0f);
      ep.addEnemy(this ,BOUND ,new Straight() ,10 ,fx ,fy ,fz ,cos(aim - PI / 2) * 5.0f ,sin(aim - PI / 3) * 5.0f);
    }
  }
  public void bonk(float fr){
  }
  public void roll(){
    rotateY(HALF_PI);
    rotateX(TWO_PI * (float)(cnt % 180) / 180);
  }
}
Shape SCATTER_SHAPE;
class Scatter extends Enemy {
  Scatter(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 60;
    attackTerm = 30;
    vanishTerm = 600;
    if(SCATTER_SHAPE == null){
      float[][] a = {
        {-0.6f ,-1 ,-0.6f  ,1.0f ,0.4f},
        {-0.6f ,0  ,0     ,0  ,0.4f}
      };
      float[][] b ={
       {0 ,0.5f  ,1.0f ,0.4f ,0},
       {0 ,0.6f  ,0.6f  ,0.6f,0}
     };
      SCATTER_SHAPE = new Pole(a ,b ,6);
    }
    shape = (Shape)SCATTER_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){
    if(attackCnt % 10 == 0){
      float drad = PI / 30.0f;
      float aim = atan2(vy ,vx);
      float si ,co;
      float dsi ,dco;
      float temp;
      si = sin(aim - PI / 3.0f);
      co = cos(aim - PI / 3.0f);
      dsi = sin(drad);
      dco = cos(drad);
      for(float i = -PI /3.0f;i <= PI / 3.0f;i += drad){
        temp = co;
        co = co * dco - si * dsi;
        si = temp * dsi + si * dco;
        ep.addEnemy(this ,BULLET ,new Straight() ,1 ,fx ,fy ,fz ,co * 3.0f,si * 3.0f);
      }
    }
  }
  public void bonk(float fr){
  }
  public void roll(){
    
    rotateZ(aim());
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
  }
}
Shape PLANE_SHAPE;
class Plane extends Enemy {
  Plane(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 60;
    attackTerm = 30;
    vanishTerm = 600;
    if(PLANE_SHAPE == null){
      float[][] a = {
        {-1.0f ,-0.8f ,-0.6f ,0.2f ,1.4f},
        {-1.0f ,-1.0f ,-0.6f ,0.2f ,0.2f}
      };
      float[][] b ={
       {0 ,0.8f  ,1.2f ,0.6f ,0.0f},
       {0.2f ,0.2f  ,0.4f ,0.2f ,0.2f}
     };
      PLANE_SHAPE = new Pole(a ,b ,4);
    }
    shape = (Shape)PLANE_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){
    if(attackCnt % 5 == 0 && 15 < attackCnt ){
      float vr = dist(0 ,0 ,vx ,vy);
      ep.addEnemy(this ,BULLET ,new Straight() ,5 ,fx ,fy ,fz ,vx / vr * 6.0f ,vy / vr *6.0f);
    }
  }
  public void bonk(float fr){
  }
  public void roll(){
    rotateZ(aim());
  }
}
Shape NIGHTWING_SHAPE;
class Nightwing extends Enemy {
  Nightwing(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 60;
    attackTerm = 60;
    vanishTerm = 600;
    if(NIGHTWING_SHAPE == null){
      float[][] a = {
        {0 ,0.2f ,0   ,-1.0f ,0.8f ,1.0f ,0.9f ,0.7f},
        {0 ,0.2f ,0.2f ,0.2f  ,0.5f ,0.5f ,0.5f ,0.0f}
      };
      float[][] b ={
       {0  ,0.4f ,0.8f ,1.2f  ,1.0f ,0.6f ,0.2f ,0.0f},
       {0  ,0.3f  ,0.5f ,0.6f ,0.5f ,0.5f ,0.3f ,0.0f}
     };
      NIGHTWING_SHAPE = new Pole(a ,b ,8);
    }
    shape = (Shape)NIGHTWING_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){
    if(20 < attackCnt){
      if(attackCnt < 40){
        if(attackCnt % 3 == 0){
          float vr = dist(0 ,0 ,vx ,vy);
          ep.addEnemy(this ,BULLET ,new Straight() ,5 ,fx ,fy ,fz ,vx / vr * 8.0f ,vy / vr * 8.0f);
        }
      }else if(attackCnt == 55){
        float vr = dist(0 ,0 ,vx ,vy);
        ep.addEnemy(this ,MISSILE ,new Homing(TWO_PI / 180.0f) ,20 ,fx ,fy ,fz ,- vx / vr * 5.0f ,- vy / vr * 5.0f);
      }
    }
  }
  public void bonk(float fr){
  }
  public void roll(){
    rotateZ(aim());
    rotateY(- HALF_PI * max((1 - PApplet.toFloat(max(cnt - 80,0)) / 30.0f) ,0));
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
    
  }
}
Shape ICEBERG_SHAPE;
class Iceberg extends Enemy {
  Iceberg(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 60;
    attackTerm = 30;
    vanishTerm = 600;
    if(ICEBERG_SHAPE == null){
      float[][] a = {
        {0 ,-0.5f ,0 ,1.0f ,0},
        {0}
      };
      float[][] b ={
       {0  ,0.5f ,1.0f ,0.5f ,0.0f},
       {0.5f}
     };
      ICEBERG_SHAPE = new Pole(a ,b ,8);
    }
    shape = (Shape)ICEBERG_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){
    if(attackCnt % 10 == 0){
      float fr = dist(fx ,fy ,ship.fx ,ship.fy);
      ep.addEnemy(this ,BOUND ,new Straight() ,5 ,fx ,fy ,fz , (ship.fx -fx) / fr * 5.0f ,(ship.fy -fy) / fr * 5.0f);
    }
  }
  public void bonk(float fr){
  }
  public void roll(){
    rotateY(- HALF_PI);
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
    
  }
}
Shape SWINE_SHAPE;
class Swine extends Enemy {
  Swine(Enemy parent ,Moving moving ,float hp ,float fx ,float fy, float fz ,float vx ,float vy){
    super(parent ,moving ,hp ,fx ,fy ,fz ,vx ,vy);
    power = 10.0f;
    reloadTerm = 45;
    attackTerm = 20;
    vanishTerm = 600;
    if(SWINE_SHAPE == null){
      float[][] a = {
        {-1.0f ,-0.8f ,-0.6f ,0.2f ,1.2f ,0.2f},
        {-1.0f ,-0.8f ,-0.6f ,0.2f ,0.4f ,0.4f}
      };
      float[][] b ={
       {0 ,0.8f  ,1.2f ,0.6f ,0.3f ,0},
       {0 ,0.4f  ,0.6f ,0.4f ,0.4f ,0.2f}
     };
      SWINE_SHAPE = new Pole(a ,b ,4);
    }
    shape = (Shape)SWINE_SHAPE.clone();
    shape.multi(largeness);
  }
  public void attack(int attackTerm ,int attackCnt){
  }
  public void bonk(float fr){
  }
  public void roll(){
     rotateZ(aim());
    rotateX(TWO_PI * (float)(cnt % 60) / 60);
    
  }
}
class EnemyPool {
  private ArrayList enemies;
  EnemyPool(){
    init();
  }
  public void init(){
    if(enemies != null){
      enemies.clear();
    }else enemies = new ArrayList();
  }
  public void addEnemy(Enemy parent ,int type ,Moving moving ,float hp ,float x ,float y ,float z ,float vx ,float vy){
    Enemy e;
    switch(type){
      case BULLET:   e =new Bullet(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case MISSILE:  e =new Missile(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case BOUND:    e =new Bound(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case THREEWAY: e =new Threeway(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case FOURWAY:  e =new Fourway(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case SCATTER:  e =new Scatter(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case PLANE:    e =new Plane(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case NIGHTWING:e =new Nightwing(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case ICEBERG:  e =new Iceberg(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      case SWINE:    e =new Swine(parent ,moving ,hp ,x ,y ,z ,vx ,vy);break;
      default:
      e =null;break;
    }
    moving.set(e);
    enemies.add(e);
  }
  public void update(){
    int i = enemies.size() - 1;
      while(0 <=i){
        Enemy e = (Enemy)enemies.get(i);
        popMatrix();
        pushMatrix();
        e.update();
        if(e.isExist() == false){
          enemies.remove(i);
        }
        i--;
      }
    }
    public void allDamage(float power){
      int i = enemies.size() - 1;
      while(0 <=i){
        Enemy e = (Enemy)enemies.get(i);
        e.damage(power);
        i--;
      }
    }
}

class Field {
  float x ,y ,z;
  float radius;
   Field(){
    init();
  }
   public void init(){
    radius = 400;
    x = y = z = 0;
  }
   public void update(){
    stroke(255);
    
    noFill();
   strokeWeight((stage.level - 1) / 100 + 1);
    if(0 < stage.level && (stage.level - 1) % 100 != 0){
      stroke(255);
      arc(0 ,0 ,radius * 2 ,radius * 2 ,(PI * 3.0f / 2.0f) ,(PI * 3.0f / 2.0f + TWO_PI / 100 * ((stage.level - 1) % 100) ));
      stroke(122);
      arc(0 ,0 ,radius * 2 ,radius * 2 ,(PI * 3.0f / 2.0f + TWO_PI  / 100 * ((stage.level - 1) % 100) ) ,(-PI / 2 + TWO_PI));
    }else{
      stroke(122);
      ellipse(x ,y ,radius * 2 ,radius * 2);
    }
    strokeWeight(1);
    //ellipse(x ,y ,radius * 2 ,radius * 2);
  }
   public float transX(float x,float y ,float z){
    return this.x + x;
  }
   public float transY(float x,float y ,float z){
    return this.y + y;
  }
   public float transZ(float x,float y ,float z){
    return this.z + z;
  }
}

abstract class Moving {
  Enemy e;
  Moving(){}
  public void set(Enemy enemy){
    this.e = enemy;
    init();
  }
  public void init(){}
  public abstract void update(boolean attacking);
}
class Straight extends Moving{
  public void update(boolean attacking){
    if(attacking ==false){
      e.fx += e.vx;
      e.fy += e.vy;
    }
  }
}
class Homing extends Moving{
  float si,co;
  Homing(float drad){
    super();
    si = sin(drad);
    co = cos(drad);
  }
  public void update(boolean attacking){
    float temp;
    float in = (ship.fx - e.fx) * -e.vy + (ship.fy - e.fy) * e.vx;
    if(in < 0){
      temp = e.vx;
      e.vx = temp * co + e.vy * si;
      e.vy = - temp * si + e.vy * co;
      
    }else{      
      temp = e.vx;
      e.vx = temp * co - e.vy * si;
      e.vy = temp * si + e.vy * co;
      
    }
    if(attacking ==false){
      e.fx += e.vx;
      e.fy += e.vy;
    }
    
  }
}
class Dart extends Moving{
  float si,co;
  Dart(float drad){
    super();
    si = sin(drad);
    co = cos(drad);
  }
  public void update(boolean attacking){
    if(attacking ==false){
      e.fx += e.vx;
      e.fy += e.vy;
    }else{
      float temp;
      float in = (ship.fx - e.fx) * -e.vy + (ship.fy - e.fy) * e.vx;
      if(in < 0){
        temp = e.vx;
        e.vx = temp * co + e.vy * si;
        e.vy = - temp * si + e.vy * co;
      
      }else{      
        temp = e.vx;
        e.vx = temp * co - e.vy * si;
        e.vy = temp * si + e.vy * co;
      
      }
    }
    
    
  }
}

class Pointer {
  float x,y,z;
  float fx ,fy ,fz;
  private Shape shape;
   Pointer(){
    init();
    float[] a = {5 ,10 ,20};
    float[] b = {0 ,5 ,0};
    shape = new Pole(a ,b ,2);
    //shape = new Symmentry(s,4);
  }
   public void init(){
    x = 0;
    y = 0;
    z = 0;
    fx = 0;
    fy = 0;
    fz = 0;
  }
   public void update(){
    fx = mouseX + ship.x - width / 2;
    fy = mouseY + ship.y - height / 2;
    fz = 0;
    x = field.transX(fx ,fy ,fz);
    y = field.transY(fx ,fy ,fz);
    z = field.transZ(fx ,fy ,fz);
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    float r = dist(x ,y ,z ,ship.x ,ship.y ,ship.z);
    noFill();
    stroke(122);
    line(ship.x ,ship.y ,ship.z ,(x - ship.x) / r * width + ship.x,(y - ship.y) / r * height + ship.y,(z - ship.z) / r * width / 2 + ship.z);
    stroke(255);
    strokeWeight(2);
    translate(x ,y ,z);
    rotateZ(PI * frameCount / 30.0f);
    
    scale(2.0f);
    for(int i = 0;i < 3;i ++){
      beginShape(LINE_LOOP);
      for(int j = 0; j < ax.length ;j ++){
        vertex(ax[j] ,ay[j] ,az[j]);
      }
      endShape();
      rotateZ(TWO_PI/3.0f);
    }
    strokeWeight(1);
  }
}

class Shape implements Cloneable{
   float[] x;
   float[] y;
   float[] z;
   Shape(){
    
  }
   Shape(float[] x,float[] y,float[] z){
    this.x =(float[])x.clone();
    this.y =(float[])y.clone();
    this.z =(float[])z.clone();
  }
   public void multi(float mul){
    x = multiple(x ,mul);
    y = multiple(y ,mul);
    z = multiple(z ,mul);
  }
   public Object clone(){
    Shape shape = new Shape(x ,y ,z);
    
    return shape;
  }
}
class Pole extends Shape{
   Pole(float[][] a ,float[][] b ,int segment){
    if(a.length != b.length || a.length < 1){
      System.out.println("Pole arguments error");
      System.exit(1);
    }
    int maxNum = 0;
    for(int i = a.length -1;0 <= i;i --){
      if(a[i].length != b[i].length || a[i].length < 1){
        System.out.println("Pole arguments error");
        System.exit(1);
      }
      if(maxNum < a[i].length)maxNum = a[i].length;
    }
    float[][] x0 = new float[segment][maxNum];
    float[][] y0 = new float[segment][maxNum];
    float[][] z0 = new float[segment][maxNum];
    int k,l;
    k = 0;
    
    for(int i = 0;i < segment ;i ++){
      for(int j = 0;j < maxNum ;j ++){
        if(j < a[k].length)l = j;
        else l = a[k].length - 1;
        x0[i][j] = a[k][l];
        y0[i][j] = b[k][l] * cos((float)i / (float)segment * TWO_PI);
        z0[i][j] = b[k][l] * sin((float)i / (float)segment * TWO_PI);
      }
      k ++;
      if(a.length <= k)k = 0;
    }
    int number = (2 * segment + 1) * maxNum;
    x = new float[number];
    y = new float[number];
    z = new float[number];
    int num = 0;
    
    for(int j = 0;j < maxNum ;j ++){
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
      for(int i = 0;i < segment ;i ++){
        x[num] = x0[i][j];
        y[num] = y0[i][j];
        z[num] = z0[i][j];
        num ++;
      }
      
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
    }
    
    int seg = 0;
    while(true){
      seg ++;
      if(segment <= seg)break; 
      for(int j = maxNum - 1;0 <= j ;j --){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
      if(segment <= seg)break; 
      for(int j = 0;j < maxNum ;j ++){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
    }
    
  }
   Pole(float[] a ,float[] b ,int segment){
    if(a.length != b.length || a.length < 1){
      System.out.println("Pole arguments error");
      System.exit(1);
    }
    float[][] x0 = new float[segment][a.length];
    float[][] y0 = new float[segment][a.length];
    float[][] z0 = new float[segment][a.length];
    for(int i = 0;i < segment ;i ++){
      for(int j = 0;j < a.length ;j ++){
        x0[i][j] = a[j];
        y0[i][j] = b[j] * cos((float)i / (float)segment * TWO_PI);
        z0[i][j] = b[j] * sin((float)i / (float)segment * TWO_PI);
      }
    }
    int number = (2 * segment + 1) * a.length;
    x = new float[number];
    y = new float[number];
    z = new float[number];
    int num = 0;
    
    for(int j = 0;j < a.length ;j ++){
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
      for(int i = 0;i < segment ;i ++){
        x[num] = x0[i][j];
        y[num] = y0[i][j];
        z[num] = z0[i][j];
        num ++;
      }
      
      x[num] = x0[0][j];
      y[num] = y0[0][j];
      z[num] = z0[0][j];
      num ++;
    }
    
    int seg = 0;
    while(true){
      seg ++;
      if(segment <= seg)break; 
      for(int j = a.length - 1;0 <= j ;j --){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
      if(segment <= seg)break; 
      for(int j = 0;j < a.length ;j ++){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
    }
  }
}
class Symmentry extends Shape{
   Symmentry(float[] a ,float[] b ,int segment){
    if(a.length != b.length || a.length < 1){
      System.out.println("Pole arguments error");
      System.exit(1);
    }
    float[][] x0 = new float[segment][a.length];
    float[][] y0 = new float[segment][a.length];
    float[][] z0 = new float[segment][a.length];
    for(int i = 0;i < segment ;i ++){
      for(int j = 0;j < a.length ;j ++){
        x0[i][j] = a[j];
        y0[i][j] = b[j] * cos((float)i / (float)segment * TWO_PI);
        z0[i][j] = b[j] * sin((float)i / (float)segment * TWO_PI);
      }
    }
    int number = segment * a.length;
    x = new float[number];
    y = new float[number];
    z = new float[number];
    int num = 0;
    
    int seg = 0;
    while(true){
      
      if(segment <= seg)break; 
      for(int j = a.length - 1;0 <= j ;j --){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
      if(segment <= seg)break; 
      for(int j = 0;j < a.length ;j ++){
        x[num] = x0[seg][j];
        y[num] = y0[seg][j];
        z[num] = z0[seg][j];
        num ++;
      }
      seg ++;
    }
  }
}


class Ship{
  final float RECMAX = 100;
  final float SPEED = 7.0f;
  final int MAXSHIELD = 5;
  float x , y ,z;
  float fx ,fy ,fz;
  float size;
  float[] px = new float[MAXSHIELD];
  float[] py = new float[MAXSHIELD];
  float[] pz = new float[MAXSHIELD];
  float[] psize = new float[MAXSHIELD];
  float[] aim = new float[2];
  Gun gun;
  int shield;
  float recGauge;
  int recCnt;
  int damCnt;
  boolean recovering;
  private Shape shape;
  private float dam;
  private int invTime;
   Ship(){
    gun = new Gun();
    init();
    float[] a = {-10 ,-20 ,30, 40 ,20 ,-5 ,5 ,30};
    float[] b = {0 ,20 ,30 ,25 ,23 ,15 ,5 ,0};
    shape = new Symmentry(a ,b ,4);
  }
   public void init(){
    gun.init();
    aim[0] = 1.0f;
    aim[1] = 0.0f;
    x = 0;
    y = 0;
    z = 0;
    size = 1.0f;
    for(int i = MAXSHIELD -1;0 <= i;i --){
      px[i] = x;
      py[i] = y;
      pz[i] = z;
      psize[i] = size;
    }
    fx = 0;
    fy = 0;
    fz = 0;
    dam = 0;
    damCnt = 0;
    invTime = 0;
    shield = MAXSHIELD;
    recGauge = 0;
    recCnt = 0;
    recovering = false;
  }
   public void update(){
    for(int i = MAXSHIELD -1;1 <= i;i --){
      px[i] = px[i-1];
      py[i] = py[i-1];
      pz[i] = pz[i-1];
      psize[i] = psize[i-1];
    }
    px[0] = x;
    py[0] = y;
    pz[0] = z;
    psize[0] = size;
    float pox = pointer.fx;
    float poy = pointer.fy;
    float r = dist(fx ,fy ,pox ,poy );
    float r1 = 70;
    float r2 = 150;
    if(0.0f < r){
      aim[0] = (pox - x) / r;
      aim[1] = (poy - y) / r;
      if(r < r1);
      else{ 
        if(r < r2){
          fx += aim[0] * SPEED;
          fy += aim[1] * SPEED;
        }else{
          fx += aim[0] * SPEED * 2.0f;
          fy += aim[1] * SPEED * 2.0f;
        }
      }
      
    }
    float fr = dist(fx ,fy ,field.x ,field.y );
    if(field.radius < fr){
      fx = (fx -field.x) * (field.radius / fr) + field.x;
      fy = (fy -field.y) * (field.radius / fr) + field.y;
    }
    x = field.transX(fx ,fy ,fz);
    y = field.transY(fx ,fy ,fz);
    z = field.transZ(fx ,fy ,fz);
    size = 0.8f + (float)(TEMPO - frameCount % TEMPO) / (float)TEMPO  * 0.2f * max(PApplet.toFloat(shield) ,0) / PApplet.toFloat(MAXSHIELD);
    
    cam.update();
    cam.setCamera();
    scale(height / 480);
    pushMatrix();
    //x = mouseX;
    //y = mouseY;
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    float sx = dam * random(5.0f);
    float sy = dam * random(5.0f);
    float sz = dam * random(5.0f);
    
    noFill();
   if(recovering){
     recCnt --;
     if(recCnt <= 0){
       recovering = false;
       shield ++;
     }
     pushMatrix();
     stroke(122);
     translate(x ,y ,z );
     
     scale(sqrt(recCnt * 10 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
    }
    if(0 < damCnt){
     damCnt --;
     pushMatrix();
     stroke(122);
     
     translate(x ,y ,z );
     
     scale(sqrt((30 - damCnt) * 20 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
   }
    stroke(155 + max(shield  ,0) * 100 / MAXSHIELD);
     
    translate(x ,y ,z );
    //ellipse(0 ,0 ,r1 * 2 ,r1 * 2);
    //ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    
   
    for(int i = MAXSHIELD - 1;0 <= i;i --){
      if(i < shield)stroke(255);
      else stroke(122);
      arc(0 ,0 ,r1 * 2 ,r1 * 2 ,(PI * 3.0f / 2.0f + TWO_PI / PApplet.toFloat(MAXSHIELD) * PApplet.toFloat(i)) ,(-PI / 2 + TWO_PI / PApplet.toFloat(MAXSHIELD) * PApplet.toFloat(i + 1)));
    }
    if(0 < recGauge){
      stroke(255);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0f / 2.0f) ,(PI * 3.0f / 2.0f + TWO_PI / RECMAX * recGauge));
      stroke(122);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0f / 2.0f + TWO_PI / RECMAX * recGauge) ,(-PI / 2 + TWO_PI));
    }else{
      stroke(122);
      ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    }
    stroke(155 + max(shield  ,0) * 100 / MAXSHIELD);
    translate(sx ,sy ,sz);
    scale(size);
    sphereDetail(4);
    sphere(20);
    stroke(1);
    
    gun.update(aim);
    if(dam > 0)dam -= 1.0f;
    else dam = 0;
    if(invTime > 0)invTime --;
    else invTime = 0;
  }
  public void inTitle(){
    fx = 0;
    fy = 0;
    fz = 0;
    float sx = dam * random(5.0f);
    float sy = dam * random(5.0f);
    float sz = dam * random(5.0f);
    float r1 = 70;
    float r2 = 150;
    x = field.transX(fx ,fy ,fz);
    y = field.transY(fx ,fy ,fz);
    z = field.transZ(fx ,fy ,fz);
    cam.update();
    cam.setCamera();
    scale(height / 480);
    
    size = 0.8f + (float)(TEMPO - frameCount % TEMPO) / (float)TEMPO  * 0.2f * max(PApplet.toFloat(shield) ,0) / PApplet.toFloat(MAXSHIELD);
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    
    noFill();
    if(recovering){
     recCnt --;
     if(recCnt <= 0){
       recovering = false;
       shield ++;
     }
 
     stroke(122);
     translate(x ,y ,z );
     pushMatrix();
     scale(sqrt(recCnt * 10 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
    }
    if(0 < damCnt){
     damCnt --;
     pushMatrix();
     stroke(122);
     
     translate(x ,y ,z );
     
     scale(sqrt((30 - damCnt) * 20 + 1));
     sphereDetail(4);
     sphere(20);
     popMatrix();
   }
    translate(x ,y ,z );
    //ellipse(0 ,0 ,r1 * 2 ,r1 * 2);
    //ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    
   
    for(int i = MAXSHIELD - 1;0 <= i;i --){
      if(i < shield)stroke(255);
      else stroke(122);
      arc(0 ,0 ,r1 * 2 ,r1 * 2 ,(PI * 3.0f / 2.0f + TWO_PI / PApplet.toFloat(MAXSHIELD) * PApplet.toFloat(i)) ,(-PI / 2 + TWO_PI / PApplet.toFloat(MAXSHIELD) * PApplet.toFloat(i + 1)));
    }
    if(0 < recGauge){
      stroke(255);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0f / 2.0f) ,(PI * 3.0f / 2.0f + TWO_PI / RECMAX * recGauge));
      stroke(122);
      arc(0 ,0 ,r2 * 2 ,r2 * 2 ,(PI * 3.0f / 2.0f + TWO_PI / RECMAX * recGauge) ,(-PI / 2 + TWO_PI));
    }else{
      stroke(122);
      ellipse(0 ,0 ,r2 * 2 ,r2 * 2);
    }
    stroke(155 + max(shield  ,0) * 100 / MAXSHIELD);
    scale(size);
    translate(sx ,sy ,sz);
    sphereDetail(4);
    sphere(20);
    stroke(1);
    if(dam > 0)dam -= 1.0f;
    else dam = 0;
    if(invTime > 0)invTime --;
    else invTime = 0;
  }
  public void damage(float power){
    if(invTime <= 0){
      ep.allDamage(10);
      dam += power;
      damCnt = 30;
      shield --;
      System.out.println(shield);
      invTime = 15;
    }
  }
  public void recPlus(float value){
    recGauge += value;
    if(RECMAX < recGauge && recovering == false){
      recovery();
      recGauge -= RECMAX;
      //System.out.println(shield);
    }
    //System.out.println(recGauge);
  }
  public void recovery(){
    if(shield < 5){
      recovering = true;
      recCnt = 30;
    }else shield = 5;
    
  }
}
class Gun {
  private Shape shape;
  private int bulCnt;
  Enemy lock;
   Gun(){
    float[] a = {-10 ,0 ,18 ,30};
    float[] b = {0 ,10 ,6 ,0};
    shape = new Pole(a ,b ,5);
    
  }
  public void init(){
    bulCnt = 0;
    lock = null;
  }
   public void update(float[] aim){
    //System.out.println(lock);
    bulCnt --;
    float[] ax = shape.x;
    float[] ay = shape.y;
    float[] az = shape.z;
    if(mousePressed){
      bulCnt = 10;
    }else {
      lock = null;
      sp.release();
    }
    float[] daim =new float[2];
    float dtheta = TWO_PI * (1.0f - random(2.0f)) / 30.0f;
    daim[0] = aim[0] * cos(dtheta) + aim[1] * sin(dtheta);
    daim[1] = aim[1] * cos(dtheta) + aim[0] * sin(dtheta);
    if(0 <= bulCnt){
      if(lock != null){
        if(lock.isExist() == false || lock.destroyed){
          sp.shot(ship.fx ,ship.fy ,daim[0] * 40.0f ,aim[1] *40.0f);
          lock = null;
        }else {
          float r = dist(ship.fx ,ship.fy ,lock.fx ,lock.fy );
          sp.shot(ship.fx ,ship.fy ,(lock.fx - ship.fx) / r * 40.0f ,(lock.fy - ship.fy) / r * 40.0f);
        }
      }
      else sp.shot(ship.fx ,ship.fy ,daim[0] * 40.0f ,daim[1] *40.0f);
    }
    
    if(lock != null){
      popMatrix();
      pushMatrix();
      stroke(255);
      
      //strokeCap(ROUND);
      noFill();
      translate(lock.x + lock.sx,lock.y + lock.sy,lock.z + lock.sz);
      strokeWeight(4);
      rect(- 40 ,- 40 ,80 ,80);
      strokeWeight(1);
/*
      pushMatrix();      
      rotateZ(TWO_PI * (float)frameCount / 60.0);
      translate(lock.size + 20 ,0 ,0);
      box(10);
      popMatrix();
      rotateZ(TWO_PI * (float)frameCount / 60.0 + PI);
      translate(lock.size + 20 ,0 ,0);
      box(10);
      */
    }
    /*
    if(aim[0] > 0){
      rotateZ(atan(aim[1]/aim[0]));
    }else{
      rotateZ(atan(aim[1]/aim[0]) + PI);
    }
    rotateX(PI * frameCount / 120.0f);
    translate (40 ,0);
    beginShape(LINE_LOOP);
    for(int i = 0; i < ax.length ;i ++){
      vertex(ax[i] ,ay[i] ,az[i]);
    }
    endShape();
    */
  }
}

Shape SHOT_SHAPE; 
Shape SHOT_RING_SHAPE;
float SHOT_MAXPOWER = 2.0f;
float SHOT_SIZE = 20.0f;
class Shot{
  private Shape shape;
  private Shape ring;
  float fx ,fy ,fz;
  float x ,y ,z;
  float vx ,vy ,vz;
  float power;
  private boolean exist;
  private boolean released;
  private int cnt;
   Shot(float x ,float y ,float vx ,float vy ){
    // System.out.println("b");
    this.fx = x;
    this.fy = y;
    fz = 0;
    this.x = field.transX(fx ,fy ,fz);
    this.y = field.transY(fx ,fy ,fz);
    this.z = field.transZ(fx ,fy ,fz);
    this.vx = vx;
    this.vy = vy;
    exist = true;
    released = false;
    cnt = 0;
    power = SHOT_MAXPOWER;
    if(SHOT_SHAPE == null){
      float[] a = {-30 ,0 ,10, 20 ,30 ,40};
      float[] b = {0 ,10 ,15 ,20 ,15 ,5};
      SHOT_SHAPE = new Pole(a ,b ,6);
    }
    shape = (Shape)SHOT_SHAPE.clone();
    if(SHOT_RING_SHAPE == null){
      float[] a = {0 ,5 ,0 ,- 5 ,0};
      float[] b = {30 ,40 ,50, 40 ,30};
      
      SHOT_RING_SHAPE = new Pole(a ,b ,8);
    }
    ring = (Shape)SHOT_RING_SHAPE.clone();
  }
   public Enemy update(){
    // System.out.println("c");
    fx += vx;
    fy += vy;
    this.x = field.transX(fx ,fy ,fz);
    this.y = field.transY(fx ,fy ,fz);
    this.z = field.transZ(fx ,fy ,fz);
    float[] ax;
    float[] ay;
    float[] az;
    if(cnt == 0){
      ax = ring.x;
      ay = ring.y;
      az = ring.z;
    }else{
      ax = shape.x;
      ay = shape.y;
      az = shape.z;
    }
    stroke(255);
    noFill();
    translate(x , y , z);
    if(vx > 0){
      rotateZ(atan(vy/vx));
    }else{
      rotateZ(atan(vy/vx) + PI);
    }
    rotateX(PI * frameCount / 20.0f);
   
    //scale(0.7);
    beginShape(LINE_LOOP);
    for(int i = 0; i < ax.length ;i ++){
      vertex(ax[i] ,ay[i] ,az[i]);
    }
    endShape();
    Enemy lock = null;
    for(int i = ep.enemies.size() - 1;0 <= i;i --){
     Enemy e = (Enemy)ep.enemies.get(i);

     if(dist(e.x ,e.y ,e.z ,x ,y ,z) < (SHOT_SIZE + e.largeness)){
       float hp = e.damage(power);
       if(power <= hp){
         vanish();
         if(released == false)lock = e;
       }
     }
     
    }
    if(cnt > 60)exist =false;
    cnt ++;
    return lock;
  }
  public void vanish(){
    exist = false;
  }
  public boolean isExist(){
    return exist;
  }
  public void release(){
    released = true;
  }
}
class ShotPool {
  private ArrayList shots;
   ShotPool(){
    init();
  }
   public void init(){
    if(shots != null){
      shots.clear();
    }else shots = new ArrayList();
  }
   public void shot(float x ,float y ,float vx ,float vy ){
    //System.out.println("a");
    Shot s =new Shot(x ,y ,vx ,vy);
    shots.add(s);
  }
   public void update(){
    Enemy lock = null;
    int i = shots.size() - 1;
    
    while(0 <=i){
      Shot s = (Shot)shots.get(i);
      popMatrix();
      pushMatrix();
      
      Enemy lo = s.update();
      if(lo != null)lock = lo;
      if(s.exist == false){
        shots.remove(i);
      }
      i--;
    }
    if(ship.gun.lock == null && lock != null)ship.gun.lock = lock;
  }
  public void release(){
    int i = shots.size() - 1;
    while(0 <=i){
      Shot s = (Shot)shots.get(i);
      s.release();
      i --;
    }
  }
}

class Stage{
  int level;
  int levCnt;
  float wait;
  float rank;
  float delay;
  public void init(int level){
    this.level = level;
    wait = 60;
    delay = 0;
    levCnt = 0;
    setRank(level);
  }
  public void update(){
    
    if(wait < delay){
      int[][] eLevList ={
        {1 ,2},
        {0 ,5},
        {3 ,6},
        {4}
      };
      float eLev = (rank - 1) * 10;
      float w = 0;
      while(wait < (rank - 1) * 500.0f){
        int lv = floor(random(constrain(eLev,0 ,eLevList.length)));
        while(eLevList[lv].length == 0){
          lv --;
          if(lv < 0)return;
        }
        int type = eLevList[lv][floor(random(eLevList[lv].length))];
        float theta = random(TWO_PI);
        float aim = random(TWO_PI);
      //ep.addEnemy(null ,type ,new Homing(TWO_PI / 180) ,100 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(aim) * 5.0 ,- sin(aim) * 5.0);
        switch(type){
          case 0:
          ep.addEnemy(null ,ICEBERG ,new Dart(TWO_PI / 180.0f) ,20 ,cos(theta) * (field.radius - 200) ,sin(theta) * (field.radius - 200) ,-400 ,- cos(theta) * 5.0f ,- sin(theta) * 5.0f);
          w = 40.0f;
          break;
          case 1:
          ep.addEnemy(null ,NIGHTWING ,new Homing(TWO_PI / 180) ,80 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius -100) ,-400 ,- cos(aim) * 5.0f ,- sin(aim) * 5.0f);
          w = 200.0f;
          break;
          case 2:
          ep.addEnemy(null ,PLANE ,new Dart(TWO_PI / 90) ,30 ,cos(theta) * (field.radius + 400) ,sin(theta) * (field.radius + 400) ,0 ,- cos(theta) * 6.0f ,- sin(theta) * 6.0f);
          w = 80.0f;
          break;
          case 3:
          ep.addEnemy(null ,THREEWAY ,new Homing(TWO_PI / 180) ,60 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(aim) * 5.0f ,- sin(aim) * 5.0f);
          w = 200.0f;
          break;
          case 4:
          ep.addEnemy(null ,FOURWAY ,new Homing(TWO_PI / 180) ,80 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(aim) * 5.0f ,- sin(aim) * 5.0f);
          w = 200.0f;
          break;
          case 5:
          ep.addEnemy(null ,SCATTER ,new Homing(TWO_PI / 180) ,80 ,cos(theta) * (field.radius - 100) ,sin(theta) * (field.radius - 100) ,-400 ,- cos(theta) * 5.0f ,- sin(theta) * 5.0f);
          w = 200.0f;
          break;
          case 6:
          ep.addEnemy(null ,SWINE ,new Dart(TWO_PI / 45) ,10 ,cos(theta) * (field.radius + 400) ,sin(theta) * (field.radius + 400) ,0 ,- cos(theta) * 9.0f ,- sin(theta) * 9.0f);
          w = 30.0f;
          break;
        }
        wait += w;
        eLev -= w / 100;
        if(random(1) < 0.5f)break;
      }
    }
    wait -= sqrt(rank);
    delay = (1 - random(2)) * rank * 30;
    levCnt ++;
    if(180 < levCnt){
      level ++;
      setRank(level);
      levCnt = 0;
    }
  }
  public void setRank(int level){
    int lev1 = (level - 1) % 10;
    int lev10 = (level - 1) / 10;
    rank = 1 + PApplet.toFloat(lev1) * (0.02f + PApplet.toFloat(lev10) * 0.001f) + PApplet.toFloat(lev10) * 0.04f;
    //System.out.println(rank);
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "ES" });}}