import krister.Ess.*;
import processing.opengl.*;
import java.awt.Graphics;
Mainloop mainloop;
Ship ship;
Pointer pointer;
ShotPool sp;
Camera cam;
Field field;
Stage stage;
EnemyPool ep;
AudioChannel myChannel;
AudioChannel se;
boolean noPlay;
boolean mouseReleased;
final int TEMPO = 15;
void setup(){
  size(480 ,480 ,OPENGL);
  framerate(30);
  Ess.start(this);
  myChannel = new AudioChannel("loop1.wav");
  noPlay = true;
  mainloop = new Mainloop();
  mainloop.init();
  
}
int pos = 0;
void draw() {
 
  mainloop.update();
}
void mouseReleased(){
  mouseReleased = true;
}
boolean getMouseReleased(){
  boolean mr =mouseReleased;
  mouseReleased = false;
  return mr;
}
float[] multiple(float[] a,float mul){
  float[] b = new float[a.length];
  for(int i = a.length - 1;0 <= i;i --){
    b[i] = a[i] * mul;
  }
  return b;
}
float[][] multiple(float[][] a,float mul){
  float[][] b = new float[a.length][];
  for(int i = a.length - 1;0 <= i;i --){
    b[i] = new float[a[i].length];
    for(int j = a[i].length - 1;0 <= j;j --){
      b[i][j] = a[i][j] * mul;
    }
  }
  return b;
}
class Mainloop{
  final State TITLE ,GAME;
  State state;
   Mainloop(){
     ship = new Ship();
     pointer = new Pointer();
     sp = new ShotPool();
     cam = new Camera();
     field = new Field();
     ep = new EnemyPool();
     stage = new Stage();
     TITLE = new Title();
     GAME = new Game();
     state = TITLE;
  }
   void init(){
     state.init();
  }
   void update(){
    state.update();
  }
   void changeState(State s){
    state = s;
    init();
  }
}
interface State{
  void init();
  void update();
}
class Game implements State{
  void init(){
    ship.init();
    pointer.init();
    sp.init();
    cam.init();
    field.init();
    ep.init();
    stage.init(1);
  }
  void update(){
    noCursor();
    background(0,50,60);
    smooth();
    ellipseMode(CENTER);
    pushMatrix();
    
    ship.update();
    popMatrix();
    pushMatrix();
    
    pointer.update();
    
    sp.update();
    popMatrix();
    
    pushMatrix();
    ep.update();
    popMatrix();
    pushMatrix();
    field.update();
    stage.update();
    popMatrix();
    popMatrix();
    if(ship.shield < 0)mainloop.changeState(mainloop.TITLE);
    if(noPlay){
      if(myChannel.state == Ess.PLAYING)myChannel.stop();
    }else{
      if(myChannel.state == Ess.STOPPED)myChannel.resume();
    }
  }
}
class Title implements State{
  void init(){
    ship.shield = ship.MAXSHIELD;
    pointer.fx = ship.fx;
    pointer.fy = ship.fy;
  }
  void update(){
    if(dist(width / 2 ,height / 2 ,mouseX ,mouseY) < 20 * height / 480){
      cursor(HAND);
      if(mousePressed && getMouseReleased()){
        mainloop.changeState(mainloop.GAME);
        
      }
    }else if(dist(width / 2 + height * 2.0 / 5.0 ,height * 9.0 / 10.0 ,mouseX ,mouseY) <  20 * height / 480){
      cursor(HAND);
      if(mousePressed && getMouseReleased()){
        if(noPlay){
          noPlay = false;
          myChannel.play(Ess.FOREVER);
        }else noPlay = true;
      }
    }else{
      cursor(ARROW);
    }
    background(0,50,60);
    smooth();
    
    ellipseMode(CENTER);
    ellipse(height * 2.0 / 5.0 ,height * 2.0 / 5.0 ,height / 12 ,height / 12);

    cam.inTitle();
    cam.setCamera();
    pushMatrix();
    scale(height / 480); 
    pushMatrix();
    ship.inTitle();
    popMatrix();
    field.update();
    popMatrix();
    
    stroke(122);
    if(noPlay)fill(122);
    else fill(255);
    //ellipse(modelX(width / 2 ,height / 2 ,0) ,modelY(width / 2 ,height / 2 ,0) ,80 ,80);
    //ellipse((width / 2 + height  / 3.0) / 2.0 ,(width * 5.0 / 6.0) / 2.0 ,height / 6 ,height / 6);
    //translate(height * 5.0 / 6.0 ,height * 5.0 / 6.0  ,0.0);
    //translate(screenX(height / 2  - 50 ,height / 2  - 50 ,0) ,screenY(height / 2  - 50 ,height / 2  - 50 ,0),screenZ(height / 2  - 50 ,height / 2  - 50 ,0));
    //ellipse(0 ,0 ,height / 6 ,height / 6);

    if(noPlay){
      if(myChannel.state == Ess.PLAYING)myChannel.stop();
    }else{
      if(myChannel.state == Ess.STOPPED)myChannel.resume();
    }
  }
}
class Camera{
  float eyeX ,eyeY ,eyeZ;
  float centerX ,centerY ,centerZ;
  float upX ,upY ,upZ;
   Camera(){
    init();
  }
  void init(){
    eyeX = 0;
    eyeY = 0;
    eyeZ = (height/2.0) / tan(PI*60.0 / 360.0);
    centerX = 0;
    centerY = 0;
    centerZ = 0;
    upX = 0;
    upY = 1;
    upZ = 0;
  }
  void inTitle(){
    eyeX = 0;
    eyeY = 0;
    eyeZ = (height) / tan(PI*60.0 / 360.0);
    centerX = 0;
    centerY = 0;
    centerZ = 0;
    upX = 0;
    upY = 1;
    upZ = 0;
  }
 
   void update(){
    eyeX = ship.x * height / 480;
    eyeY = ship.y * height / 480;
    eyeZ = ship.z + (height/2.0) / tan(PI*60.0 / 360.0);
    centerX = ship.x * height / 480;
    centerY = ship.y * height / 480;
    centerZ = ship.z;
    upX = 0;
    upY = 1;
    upZ = 0;
  }
   void setCamera(){
    camera(eyeX ,eyeY ,eyeZ ,centerX ,centerY ,centerZ ,upX ,upY ,upZ);
  }
}
  
