Shape SHOT_SHAPE; 
Shape SHOT_RING_SHAPE;
float SHOT_MAXPOWER = 2.0;
float SHOT_SIZE = 20.0;
class Shot{
  private Shape shape;
  private Shape ring;
  float fx ,fy ,fz;
  float x ,y ,z;
  float vx ,vy ,vz;
  float power;
  private boolean exist;
  private boolean released;
  private int cnt;
   Shot(float x ,float y ,float vx ,float vy ){
    // System.out.println("b");
    this.fx = x;
    this.fy = y;
    fz = 0;
    this.x = field.transX(fx ,fy ,fz);
    this.y = field.transY(fx ,fy ,fz);
    this.z = field.transZ(fx ,fy ,fz);
    this.vx = vx;
    this.vy = vy;
    exist = true;
    released = false;
    cnt = 0;
    power = SHOT_MAXPOWER;
    if(SHOT_SHAPE == null){
      float[] a = {-30 ,0 ,10, 20 ,30 ,40};
      float[] b = {0 ,10 ,15 ,20 ,15 ,5};
      SHOT_SHAPE = new Pole(a ,b ,6);
    }
    shape = (Shape)SHOT_SHAPE.clone();
    if(SHOT_RING_SHAPE == null){
      float[] a = {0 ,5 ,0 ,- 5 ,0};
      float[] b = {30 ,40 ,50, 40 ,30};
      
      SHOT_RING_SHAPE = new Pole(a ,b ,8);
    }
    ring = (Shape)SHOT_RING_SHAPE.clone();
  }
   Enemy update(){
    // System.out.println("c");
    fx += vx;
    fy += vy;
    this.x = field.transX(fx ,fy ,fz);
    this.y = field.transY(fx ,fy ,fz);
    this.z = field.transZ(fx ,fy ,fz);
    float[] ax;
    float[] ay;
    float[] az;
    if(cnt == 0){
      ax = ring.x;
      ay = ring.y;
      az = ring.z;
    }else{
      ax = shape.x;
      ay = shape.y;
      az = shape.z;
    }
    stroke(255);
    noFill();
    translate(x , y , z);
    if(vx > 0){
      rotateZ(atan(vy/vx));
    }else{
      rotateZ(atan(vy/vx) + PI);
    }
    rotateX(PI * frameCount / 20.0f);
   
    //scale(0.7);
    beginShape(LINE_LOOP);
    for(int i = 0; i < ax.length ;i ++){
      vertex(ax[i] ,ay[i] ,az[i]);
    }
    endShape();
    Enemy lock = null;
    for(int i = ep.enemies.size() - 1;0 <= i;i --){
     Enemy e = (Enemy)ep.enemies.get(i);

     if(dist(e.x ,e.y ,e.z ,x ,y ,z) < (SHOT_SIZE + e.largeness)){
       float hp = e.damage(power);
       if(power <= hp){
         vanish();
         if(released == false)lock = e;
       }
     }
     
    }
    if(cnt > 60)exist =false;
    cnt ++;
    return lock;
  }
  void vanish(){
    exist = false;
  }
  boolean isExist(){
    return exist;
  }
  void release(){
    released = true;
  }
}
class ShotPool {
  private ArrayList shots;
   ShotPool(){
    init();
  }
   void init(){
    if(shots != null){
      shots.clear();
    }else shots = new ArrayList();
  }
   void shot(float x ,float y ,float vx ,float vy ){
    //System.out.println("a");
    Shot s =new Shot(x ,y ,vx ,vy);
    shots.add(s);
  }
   void update(){
    Enemy lock = null;
    int i = shots.size() - 1;
    
    while(0 <=i){
      Shot s = (Shot)shots.get(i);
      popMatrix();
      pushMatrix();
      
      Enemy lo = s.update();
      if(lo != null)lock = lo;
      if(s.exist == false){
        shots.remove(i);
      }
      i--;
    }
    if(ship.gun.lock == null && lock != null)ship.gun.lock = lock;
  }
  void release(){
    int i = shots.size() - 1;
    while(0 <=i){
      Shot s = (Shot)shots.get(i);
      s.release();
      i --;
    }
  }
}
